# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::Compute
  module Models
    #
    # Container service
    #
    class ContainerService < MsRestAzure::Resource

      include MsRestAzure

      # @return [String] the provisioning state, which only appears in the
      # response.
      attr_accessor :provisioning_state

      # @return [ContainerServiceOrchestratorProfile] Properties of
      # orchestrator
      attr_accessor :orchestrator_profile

      # @return [ContainerServiceMasterProfile] Properties of master agents
      attr_accessor :master_profile

      # @return [Array<ContainerServiceAgentPoolProfile>] Properties of agent
      # pools
      attr_accessor :agent_pool_profiles

      # @return [ContainerServiceWindowsProfile] Properties of Windows VMs
      attr_accessor :windows_profile

      # @return [ContainerServiceLinuxProfile] Properties for Linux VMs
      attr_accessor :linux_profile

      # @return [ContainerServiceDiagnosticsProfile] Properties for Diagnostic
      # Agent
      attr_accessor :diagnostics_profile


      #
      # Mapper for ContainerService class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          required: false,
          serialized_name: 'ContainerService',
          type: {
            name: 'Composite',
            class_name: 'ContainerService',
            model_properties: {
              id: {
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              location: {
                required: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              provisioning_state: {
                required: false,
                read_only: true,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              },
              orchestrator_profile: {
                required: false,
                serialized_name: 'properties.orchestratorProfile',
                type: {
                  name: 'Composite',
                  class_name: 'ContainerServiceOrchestratorProfile'
                }
              },
              master_profile: {
                required: true,
                serialized_name: 'properties.masterProfile',
                type: {
                  name: 'Composite',
                  class_name: 'ContainerServiceMasterProfile'
                }
              },
              agent_pool_profiles: {
                required: true,
                serialized_name: 'properties.agentPoolProfiles',
                type: {
                  name: 'Sequence',
                  element: {
                      required: false,
                      serialized_name: 'ContainerServiceAgentPoolProfileElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ContainerServiceAgentPoolProfile'
                      }
                  }
                }
              },
              windows_profile: {
                required: false,
                serialized_name: 'properties.windowsProfile',
                type: {
                  name: 'Composite',
                  class_name: 'ContainerServiceWindowsProfile'
                }
              },
              linux_profile: {
                required: true,
                serialized_name: 'properties.linuxProfile',
                type: {
                  name: 'Composite',
                  class_name: 'ContainerServiceLinuxProfile'
                }
              },
              diagnostics_profile: {
                required: false,
                serialized_name: 'properties.diagnosticsProfile',
                type: {
                  name: 'Composite',
                  class_name: 'ContainerServiceDiagnosticsProfile'
                }
              }
            }
          }
        }
      end
    end
  end
end
