# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::Compute
  module Models
    #
    # The Virtual Machine Scale Set List Skus operation response.
    #
    class VirtualMachineScaleSetListSkusResult

      include MsRestAzure

      # @return [Array<VirtualMachineScaleSetSku>] the list of skus available
      # for the virtual machine scale set.
      attr_accessor :value

      # @return [String] the uri to fetch the next page of Virtual Machine
      # Scale Set Skus. Call ListNext() with this to fetch the next page of
      # VMSS Skus.
      attr_accessor :next_link

      # return [Proc] with next page method call.
      attr_accessor :next_method

      #
      # Gets the rest of the items for the request, enabling auto-pagination.
      #
      # @return [Array<VirtualMachineScaleSetSku>] operation results.
      #
      def get_all_items
        items = @value
        page = self
        while page.next_link != nil do
          page = page.get_next_page
          items.concat(page.value)
        end
        items
      end

      #
      # Gets the next page of results.
      #
      # @return [VirtualMachineScaleSetListSkusResult] with next page content.
      #
      def get_next_page
        response = @next_method.call(@next_link).value! unless @next_method.nil?
        unless response.nil?
          @next_link = response.body.next_link
          @value = response.body.value
          self
        end
      end

      #
      # Mapper for VirtualMachineScaleSetListSkusResult class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          required: false,
          serialized_name: 'VirtualMachineScaleSetListSkusResult',
          type: {
            name: 'Composite',
            class_name: 'VirtualMachineScaleSetListSkusResult',
            model_properties: {
              value: {
                required: false,
                read_only: true,
                serialized_name: 'value',
                type: {
                  name: 'Sequence',
                  element: {
                      required: false,
                      serialized_name: 'VirtualMachineScaleSetSkuElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'VirtualMachineScaleSetSku'
                      }
                  }
                }
              },
              next_link: {
                required: false,
                serialized_name: 'nextLink',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
