# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::Dns
  module Models
    #
    # Describes a DNS RecordSet (a set of DNS records with the same name and
    # type).
    #
    class RecordSet

      include MsRestAzure

      # @return [String] Gets or sets the ID of the resource.
      attr_accessor :id

      # @return [String] Gets or sets the name of the resource.
      attr_accessor :name

      # @return [String] Gets or sets the type of the resource.
      attr_accessor :type

      # @return [String] Gets or sets the ETag of the RecordSet.
      attr_accessor :etag

      # @return [Hash{String => String}] Gets or sets the metadata attached to
      # the resource.
      attr_accessor :metadata

      # @return [Integer] Gets or sets the TTL of the records in the RecordSet.
      attr_accessor :ttl

      # @return [Array<ARecord>] Gets or sets the list of A records in the
      # RecordSet.
      attr_accessor :arecords

      # @return [Array<AaaaRecord>] Gets or sets the list of AAAA records in
      # the RecordSet.
      attr_accessor :aaaa_records

      # @return [Array<MxRecord>] Gets or sets the list of MX records in the
      # RecordSet.
      attr_accessor :mx_records

      # @return [Array<NsRecord>] Gets or sets the list of NS records in the
      # RecordSet.
      attr_accessor :ns_records

      # @return [Array<PtrRecord>] Gets or sets the list of PTR records in the
      # RecordSet.
      attr_accessor :ptr_records

      # @return [Array<SrvRecord>] Gets or sets the list of SRV records in the
      # RecordSet.
      attr_accessor :srv_records

      # @return [Array<TxtRecord>] Gets or sets the list of TXT records in the
      # RecordSet.
      attr_accessor :txt_records

      # @return [CnameRecord] Gets or sets the CNAME record in the RecordSet.
      attr_accessor :cname_record

      # @return [SoaRecord] Gets or sets the SOA record in the RecordSet.
      attr_accessor :soa_record


      #
      # Mapper for RecordSet class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          required: false,
          serialized_name: 'RecordSet',
          type: {
            name: 'Composite',
            class_name: 'RecordSet',
            model_properties: {
              id: {
                required: false,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                required: false,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              etag: {
                required: false,
                serialized_name: 'etag',
                type: {
                  name: 'String'
                }
              },
              metadata: {
                required: false,
                serialized_name: 'properties.metadata',
                type: {
                  name: 'Dictionary',
                  value: {
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              ttl: {
                required: false,
                serialized_name: 'properties.TTL',
                type: {
                  name: 'Number'
                }
              },
              arecords: {
                required: false,
                serialized_name: 'properties.ARecords',
                type: {
                  name: 'Sequence',
                  element: {
                      required: false,
                      serialized_name: 'ARecordElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ARecord'
                      }
                  }
                }
              },
              aaaa_records: {
                required: false,
                serialized_name: 'properties.AAAARecords',
                type: {
                  name: 'Sequence',
                  element: {
                      required: false,
                      serialized_name: 'AaaaRecordElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'AaaaRecord'
                      }
                  }
                }
              },
              mx_records: {
                required: false,
                serialized_name: 'properties.MXRecords',
                type: {
                  name: 'Sequence',
                  element: {
                      required: false,
                      serialized_name: 'MxRecordElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'MxRecord'
                      }
                  }
                }
              },
              ns_records: {
                required: false,
                serialized_name: 'properties.NSRecords',
                type: {
                  name: 'Sequence',
                  element: {
                      required: false,
                      serialized_name: 'NsRecordElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'NsRecord'
                      }
                  }
                }
              },
              ptr_records: {
                required: false,
                serialized_name: 'properties.PTRRecords',
                type: {
                  name: 'Sequence',
                  element: {
                      required: false,
                      serialized_name: 'PtrRecordElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'PtrRecord'
                      }
                  }
                }
              },
              srv_records: {
                required: false,
                serialized_name: 'properties.SRVRecords',
                type: {
                  name: 'Sequence',
                  element: {
                      required: false,
                      serialized_name: 'SrvRecordElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'SrvRecord'
                      }
                  }
                }
              },
              txt_records: {
                required: false,
                serialized_name: 'properties.TXTRecords',
                type: {
                  name: 'Sequence',
                  element: {
                      required: false,
                      serialized_name: 'TxtRecordElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'TxtRecord'
                      }
                  }
                }
              },
              cname_record: {
                required: false,
                serialized_name: 'properties.CNAMERecord',
                type: {
                  name: 'Composite',
                  class_name: 'CnameRecord'
                }
              },
              soa_record: {
                required: false,
                serialized_name: 'properties.SOARecord',
                type: {
                  name: 'Composite',
                  class_name: 'SoaRecord'
                }
              }
            }
          }
        }
      end
    end
  end
end
