# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::IotHub
  module Models
    #
    # The properties of the Messaging Endpoints used by this IoT Hub.
    #
    class MessagingEndpointProperties

      include MsRestAzure

      # @return [Duration] The lock duration. Range: 5 Sec (PT5S) - 5 Min
      # (PT5M).
      attr_accessor :lock_duration_as_iso8601

      # @return [Duration] The time to live. Range: 1 Min (PT1M) - 2 Days
      # (P2D).
      attr_accessor :ttl_as_iso8601

      # @return [Integer] The max delivery count. Range: 1-100.
      attr_accessor :max_delivery_count


      #
      # Mapper for MessagingEndpointProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          required: false,
          serialized_name: 'MessagingEndpointProperties',
          type: {
            name: 'Composite',
            class_name: 'MessagingEndpointProperties',
            model_properties: {
              lock_duration_as_iso8601: {
                required: false,
                serialized_name: 'lockDurationAsIso8601',
                type: {
                  name: 'TimeSpan'
                }
              },
              ttl_as_iso8601: {
                required: false,
                serialized_name: 'ttlAsIso8601',
                type: {
                  name: 'TimeSpan'
                }
              },
              max_delivery_count: {
                required: false,
                serialized_name: 'maxDeliveryCount',
                constraints: {
                  InclusiveMaximum: 100,
                  InclusiveMinimum: 1
                },
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
