# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::MobileEngagement
  #
  # A service client - single point of access to the REST API.
  #
  class EngagementManagementClient < MsRestAzure::AzureServiceClient
    include MsRestAzure
    include MsRestAzure::Serialization

    # @return [String] the base URI of the service.
    attr_accessor :base_url

    # @return Credentials needed for the client to connect to Azure.
    attr_reader :credentials

    # @return [String] Gets subscription credentials which uniquely identify
    # Microsoft Azure subscription. The subscription ID forms part of the URI
    # for every service call.
    attr_accessor :subscription_id

    # @return [String] Client Api Version.
    attr_reader :api_version

    # @return [String] The name of the resource group.
    attr_accessor :resource_group_name

    # @return [String] Application collection.
    attr_accessor :app_collection

    # @return [String] Application resource name.
    attr_accessor :app_name

    # @return [String] Gets or sets the preferred language for the response.
    attr_accessor :accept_language

    # @return [Integer] Gets or sets the retry timeout in seconds for Long
    # Running Operations. Default value is 30.
    attr_accessor :long_running_operation_retry_timeout

    # @return [Boolean] When set to true a unique x-ms-client-request-id value
    # is generated and included in each request. Default is true.
    attr_accessor :generate_client_request_id

    # @return Subscription credentials which uniquely identify client
    # subscription.
    attr_accessor :credentials

    # @return [AppCollections] app_collections
    attr_reader :app_collections

    # @return [Apps] apps
    attr_reader :apps

    # @return [SupportedPlatforms] supported_platforms
    attr_reader :supported_platforms

    # @return [Campaigns] campaigns
    attr_reader :campaigns

    # @return [Devices] devices
    attr_reader :devices

    # @return [ExportTasks] export_tasks
    attr_reader :export_tasks

    # @return [ImportTasks] import_tasks
    attr_reader :import_tasks

    #
    # Creates initializes a new instance of the EngagementManagementClient class.
    # @param credentials [MsRest::ServiceClientCredentials] credentials to authorize HTTP requests made by the service client.
    # @param base_url [String] the base URI of the service.
    # @param options [Array] filters to be applied to the HTTP requests.
    #
    def initialize(credentials, base_url = nil, options = nil)
      super(credentials, options)
      @base_url = base_url || 'https://management.azure.com'

      fail ArgumentError, 'credentials is nil' if credentials.nil?
      fail ArgumentError, 'invalid type of credentials input parameter' unless credentials.is_a?(MsRest::ServiceClientCredentials)
      @credentials = credentials

      @app_collections = AppCollections.new(self)
      @apps = Apps.new(self)
      @supported_platforms = SupportedPlatforms.new(self)
      @campaigns = Campaigns.new(self)
      @devices = Devices.new(self)
      @export_tasks = ExportTasks.new(self)
      @import_tasks = ImportTasks.new(self)
      @api_version = '2014-12-01'
      @accept_language = 'en-US'
      @long_running_operation_retry_timeout = 30
      @generate_client_request_id = true
    end

  end
end
