# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::MobileEngagement
  module Models
    #
    # Model object.
    #
    class CampaignListResult < CampaignStateResult

      include MsRestAzure

      # @return [String] Name of the campaign.
      attr_accessor :name

      # @return [DateTime] The date at which the campaign was activated (Not
      # present if not yet activated). The date conforms to the following
      # format: `yyyy-MM-ddTHH:mm:ssZ` as specified by the ISO 8601 standard.
      attr_accessor :activated_date

      # @return [DateTime] The date at which the campaign was finished (Not
      # present if not yet finished). The date conforms to the following
      # format: `yyyy-MM-ddTHH:mm:ssZ` as specified by the ISO 8601 standard.
      attr_accessor :finished_date

      # @return [DateTime] The date at which the campaign should be started if
      # specified. The date conforms to the following format:
      # `yyyy-MM-ddTHH:mm:ssZ` as specified by the ISO 8601 standard.
      # Applicable only to announcements and polls.
      attr_accessor :start_time

      # @return [DateTime] The date at which the campaign should be finished
      # if specified. The date conforms to the following format:
      # `yyyy-MM-ddTHH:mm:ssZ` as specified by the ISO 8601 standard.
      # Applicable only to announcements and polls.
      attr_accessor :end_time

      # @return [String] The id of the time zone to use for the `startTime`
      # and `endTime` dates. If not provided, the two date attributes are
      # referencing to the device timezone. Applicable only to announcements
      # and polls.
      attr_accessor :timezone


      #
      # Mapper for CampaignListResult class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          required: false,
          serialized_name: 'CampaignListResult',
          type: {
            name: 'Composite',
            class_name: 'CampaignListResult',
            model_properties: {
              state: {
                required: false,
                serialized_name: 'state',
                type: {
                  name: 'String'
                }
              },
              id: {
                required: true,
                serialized_name: 'id',
                type: {
                  name: 'Number'
                }
              },
              name: {
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              activated_date: {
                required: false,
                serialized_name: 'activatedDate',
                type: {
                  name: 'DateTime'
                }
              },
              finished_date: {
                required: false,
                serialized_name: 'finishedDate',
                type: {
                  name: 'DateTime'
                }
              },
              start_time: {
                required: false,
                serialized_name: 'startTime',
                type: {
                  name: 'DateTime'
                }
              },
              end_time: {
                required: false,
                serialized_name: 'endTime',
                type: {
                  name: 'DateTime'
                }
              },
              timezone: {
                required: false,
                serialized_name: 'timezone',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
