# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::MobileEngagement
  module Models
    #
    # Used to target devices based on a specific region. A center point
    # (defined by a latitude and longitude) and a radius form the boundary
    # for the region. This criterion will be met when the user crosses the
    # boundaries of the region.
    #
    class GeoFencingCriterion < Criterion

      include MsRestAzure


      def initialize
        @type = "geo-fencing"
      end

      attr_accessor :type

      # @return [Float] The latitude of the central point of the region.
      attr_accessor :lat

      # @return [Float] The longitude of the central point of the region.
      attr_accessor :lon

      # @return [Integer] The radius of the central point of the region, in
      # meters.
      attr_accessor :radius

      # @return [Integer] Number of minutes before device location is
      # considered to be expired.
      attr_accessor :expiration


      #
      # Mapper for GeoFencingCriterion class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          required: false,
          serialized_name: 'geo-fencing',
          type: {
            name: 'Composite',
            class_name: 'GeoFencingCriterion',
            model_properties: {
              type: {
                required: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              lat: {
                required: false,
                serialized_name: 'lat',
                type: {
                  name: 'Double'
                }
              },
              lon: {
                required: false,
                serialized_name: 'lon',
                type: {
                  name: 'Double'
                }
              },
              radius: {
                required: false,
                serialized_name: 'radius',
                type: {
                  name: 'Number'
                }
              },
              expiration: {
                required: false,
                serialized_name: 'expiration',
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
