# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::Search
  module Models
    #
    # Describes an Azure Search service and its current state.
    #
    class SearchServiceResource

      include MsRestAzure

      # @return [String] The resource Id of the Azure Search service.
      attr_accessor :id

      # @return [String] The name of the Search service.
      attr_accessor :name

      # @return [String] The geographic location of the Search service.
      attr_accessor :location

      # @return [Hash{String => String}] Tags to help categorize the Search
      # service in the Azure Portal.
      attr_accessor :tags

      # @return [SearchServiceReadableProperties] Properties of the Search
      # service.
      attr_accessor :properties


      #
      # Mapper for SearchServiceResource class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          required: false,
          serialized_name: 'SearchServiceResource',
          type: {
            name: 'Composite',
            class_name: 'SearchServiceResource',
            model_properties: {
              id: {
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              location: {
                required: false,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              properties: {
                required: false,
                read_only: true,
                serialized_name: 'properties',
                type: {
                  name: 'Composite',
                  class_name: 'SearchServiceReadableProperties'
                }
              }
            }
          }
        }
      end
    end
  end
end
