# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::Web
  module Models
    #
    # AutoHealTriggers - describes the triggers for auto-heal.
    #
    class AutoHealTriggers

      include MsRestAzure

      # @return [RequestsBasedTrigger] Requests - Defines a rule based on
      # total requests
      attr_accessor :requests

      # @return [Integer] PrivateBytesInKB - Defines a rule based on private
      # bytes
      attr_accessor :private_bytes_in_kb

      # @return [Array<StatusCodesBasedTrigger>] StatusCodes - Defines a rule
      # based on status codes
      attr_accessor :status_codes

      # @return [SlowRequestsBasedTrigger] SlowRequests - Defines a rule based
      # on request execution time
      attr_accessor :slow_requests


      #
      # Mapper for AutoHealTriggers class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          required: false,
          serialized_name: 'AutoHealTriggers',
          type: {
            name: 'Composite',
            class_name: 'AutoHealTriggers',
            model_properties: {
              requests: {
                required: false,
                serialized_name: 'requests',
                type: {
                  name: 'Composite',
                  class_name: 'RequestsBasedTrigger'
                }
              },
              private_bytes_in_kb: {
                required: false,
                serialized_name: 'privateBytesInKB',
                type: {
                  name: 'Number'
                }
              },
              status_codes: {
                required: false,
                serialized_name: 'statusCodes',
                type: {
                  name: 'Sequence',
                  element: {
                      required: false,
                      serialized_name: 'StatusCodesBasedTriggerElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'StatusCodesBasedTrigger'
                      }
                  }
                }
              },
              slow_requests: {
                required: false,
                serialized_name: 'slowRequests',
                type: {
                  name: 'Composite',
                  class_name: 'SlowRequestsBasedTrigger'
                }
              }
            }
          }
        }
      end
    end
  end
end
